diff --git a/src/common/gui/CModulationSourceButton.cpp b/src/common/gui/CModulationSourceButton.cpp
index 12e88f17a32..cffe5956669 100644
--- a/src/common/gui/CModulationSourceButton.cpp
+++ b/src/common/gui/CModulationSourceButton.cpp
@@ -343,4 +343,15 @@ double CModulationSourceButton::getMouseDeltaScaling(CPoint& where, const CButto
    return scaling;
 }
 
+bool CModulationSourceButton::onWheel(const VSTGUI::CPoint& where, const float &distance, const VSTGUI::CButtonState& buttons)
+{
+    value += distance / (double)(getWidth());
+    value = limit_range(value, 0.f, 1.f);
+    event_is_drag = true;
+    invalid();
+    if (listener)
+        listener->valueChanged(this);
+    return true;
+}
+
 //------------------------------------------------------------------------------------------------
diff --git a/src/common/gui/CModulationSourceButton.h b/src/common/gui/CModulationSourceButton.h
index 16bc6bcd038..8691a2c3a21 100644
--- a/src/common/gui/CModulationSourceButton.h
+++ b/src/common/gui/CModulationSourceButton.h
@@ -28,6 +28,7 @@ class CModulationSourceButton : public CCursorHidingControl
 
    virtual void onMouseMoveDelta(VSTGUI::CPoint& where, const VSTGUI::CButtonState& buttons, double dx, double dy);
    virtual double getMouseDeltaScaling(VSTGUI::CPoint& where, const VSTGUI::CButtonState& buttons);
+   virtual bool onWheel(const VSTGUI::CPoint& where, const float &distance, const VSTGUI::CButtonState& buttons);
 
    int state, msid, controlstate;
 
